import { Component, OnInit } from '@angular/core';
import {ActivatedRoute, Params} from '@angular/router';
import {User, Phone} from 'cic-client-meta';
import {first} from 'rxjs/operators';
import {User as UserModel} from '../../../_models';
import {UserService} from '../../../_services';
import {parse} from '../../../../assets/js/parse-vcard';

@Component({
  selector: 'app-user-details',
  templateUrl: './user-details.component.html',
  styleUrls: ['./user-details.component.scss']
})
export class UserDetailsComponent implements OnInit {
  user: UserModel;
  vcard: any;
  parsedVcard: any;

  constructor(
    private route: ActivatedRoute,
    private userService: UserService
  ) {
    this.route.paramMap.subscribe(
      (params: Params) => {
        this.getUser(params.get('id')).then();
        // console.log(Phone.toKey(25412341234));
        // console.log(User.toKey('0x9D7c284907acD0AA69147A9bd4a0cE2dD21a573D'));
      }
    );
  }

  ngOnInit(): void {
  }

  async getUser(address: string): Promise<void> {
    this.userService.getUser(await User.toKey(address)).pipe(first()).subscribe(res => {
      console.log(res);
      this.user = res;
      this.vcard = atob(res.vcard);
      this.parsedVcard = parse(this.vcard);
    }, error => {
      console.log(error);
    });
  }
}
